SystemOrganization addCategory: #'Pier-Book-Structures'!
SystemOrganization addCategory: #'Pier-Book-Utilities'!
SystemOrganization addCategory: #'Pier-Book-Latex'!

PRStructure subclass: #BONote
	instanceVariableNames: 'email note timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BONote class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:45'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOPublication! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:05'!
descriptionConfirmation
	^ MABooleanDescription new
		addCondition: (MACondition selector: #yourself)
			labelled: 'Please, confirm submission by clicking the checkbox';
		checkboxLabel: 'Confirm submission by clicking the checkbox';
		propertyAt: #public put: true;
		accessor: #confirmation;
		label: 'Confirmation';
		priority: 600;
		beEditable;
		yourself! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:04'!
descriptionEmail
	^ MAStringDescription new
		addCondition: (MACondition selector: #matches: argument: '#*@#*.#*')
			labelled: 'Please make sure to enter a valid E-Mail';
	 	propertyAt: #public put: true;
		accessor: #email;
		label: 'E-Mail';
		priority: 500;
		beRequired;
		beEditable;
		yourself! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:05'!
descriptionNote
	^ MAMemoDescription new
	 	propertyAt: #public put: true;
		accessor: #note;
		priority: 550;
		label: 'Note';
		lineCount: 5;
		beRequired;
		beEditable;
		yourself! !

!BONote class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:43'!
isAbstract
	^ false! !

!BONote class methodsFor: 'accessing' stamp: 'lr 5/26/2009 21:46'!
label
	^ 'Note'! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:24'!
author
	^ self email copyUpTo: $@! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 13:05'!
confirmation
	^ false! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 13:05'!
confirmation: aBoolean! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:45'!
document
	^ PRDocument new
		add: (PRParagraph with: (PRText content: self author));
		add: (PRPreformatted withAll: (self note lines
			collect: [ :each | PRText content: each ]));
		yourself! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:24'!
email
	^ email! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:24'!
email: aString 
	email := aString! !

!BONote methodsFor: 'initialization' stamp: 'lr 5/3/2009 12:29'!
initialize
	super initialize.
	email := String new.
	note := String new.
	timestamp := TimeStamp now! !

!BONote methodsFor: 'testing' stamp: 'lr 5/3/2009 12:10'!
isNote
	^ true! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:09'!
note
	^ note! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:09'!
note: aString 
	note := aString! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:29'!
timestamp
	^ timestamp! !

!PRStructure methodsFor: '*pier-book' stamp: 'lr 6/3/2009 22:44'!
isFigure
	^ false! !

!PRStructure methodsFor: '*pier-book' stamp: 'lr 5/3/2009 12:10'!
isNote
	^ false! !

!PRStructure methodsFor: '*pier-book' stamp: 'lr 4/24/2009 11:56'!
isPublication
	^ false! !

PRLink subclass: #BOIndexLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Utilities'!

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:08'!
isAbstract
	^ false! !

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:09'!
isValidReference: aString
	^ aString beginsWith: 'index:'! !

!BOIndexLink methodsFor: 'visiting' stamp: 'lr 5/1/2009 22:09'!
accept: aVisitor
	aVisitor visitIndexLink: self! !

!BOIndexLink methodsFor: 'accessing' stamp: 'lr 5/19/2009 11:41'!
entries
	^ self title findTokens: $!!! !

!BOIndexLink methodsFor: 'accessing' stamp: 'lr 5/1/2009 22:13'!
title
	^ super title copyAfter: $:! !

PRRawView subclass: #BOBookView
	instanceVariableNames: 'book'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOBookView class methodsFor: 'testing' stamp: 'lr 5/19/2009 11:29'!
isAbstract
	^ self name = #POBookView! !

!BOBookView class methodsFor: 'testing' stamp: 'lr 5/19/2009 11:28'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isPublication ]! !

!BOBookView methodsFor: 'accessing' stamp: 'lr 5/19/2009 13:48'!
book
	^ book ifNil: [ book := self findBook ]! !

!BOBookView methodsFor: 'private' stamp: 'lr 5/19/2009 13:48'!
findBook
	^ self context structure findAncestor: [ :each | each isPublication and: [ each isBook ] ]! !

!BOBookView methodsFor: 'accessing' stamp: 'lr 5/19/2009 11:37'!
writer
	^ BOLatexWriter! !

BOBookView subclass: #BOLatexView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOLatexView class methodsFor: 'accessing' stamp: 'lr 5/13/2009 09:02'!
label
	^ 'LaTeX'! !

!BOLatexView methodsFor: 'rendering' stamp: 'lr 5/19/2009 11:37'!
renderContentOn: aResponse
	aResponse contentType: 'text/latex'.
	self writer
		write: self book
		to: aResponse stream! !

BOBookView subclass: #BOPdfView
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOPdfView class methodsFor: 'accessing' stamp: 'lr 5/19/2009 11:25'!
label
	^ 'PDF'! !

!BOPdfView methodsFor: 'configuration' stamp: 'lr 5/19/2009 13:46'!
bibtex
	^ self findExecutable: 'bibtex'! !

!BOPdfView methodsFor: 'accessing' stamp: 'lr 5/19/2009 11:27'!
directory
	^ directory ifNil: [ directory := (FileDirectory default directoryNamed: 'pdf/' , DateAndTime now asSortableString) assureExistence ]! !

!BOPdfView methodsFor: 'accessing' stamp: 'lr 5/19/2009 11:53'!
filename
	^ self book name! !

!BOPdfView methodsFor: 'private' stamp: 'lr 5/19/2009 13:46'!
findExecutable: aString
	| path |
	path := #('/usr/bin' '/usr/local/bin' '/usr/texbin')
		detect: [ :each | (FileDirectory on: each) fileExists: aString ]
		ifNone: [ self error: 'The command ' , aString printString , ' cannot be found.' ].
	^ (FileDirectory on: path) fullNameFor: aString! !

!BOPdfView methodsFor: 'configuration' stamp: 'lr 5/19/2009 13:47'!
intex
	^ self findExecutable: 'makeindex'! !

!BOPdfView methodsFor: 'configuration' stamp: 'lr 5/19/2009 13:47'!
latex
	^ self findExecutable: 'pdflatex'! !

!BOPdfView methodsFor: 'accessing' stamp: 'lr 5/19/2009 13:38'!
process
	^ (Smalltalk classNamed: #OSProcess) ifNil: [ self error: 'OSProcess not found' ]! !

!BOPdfView methodsFor: 'rendering' stamp: 'lr 5/19/2009 13:37'!
renderContentOn: aResponse
	self renderPdfOn: aResponse stream.
	aResponse contentType: 'application/pdf'! !

!BOPdfView methodsFor: 'rendering' stamp: 'lr 5/19/2009 16:32'!
renderPdfOn: aStream
	| fullname stream latexCommand bibtexCommand indexCommand |
	fullname := self directory fullNameFor: self filename.
	[ stream := self directory forceNewFileNamed: self filename , '.tex'.
	[ stream nextPutAll: (self writer write: self book) ]
		ensure: [ stream close ].
	latexCommand := self latex , ' -output-directory=' , self directory fullName printString , ' -interaction=batchmode ' , (fullname , '.tex') printString.
	bibtexCommand := self bibtex , ' -output-directory=' , self directory fullName printString , ' -interaction=batchmode ' , (fullname , '.tex') printString.
	indexCommand := self intex , ' -output-directory=' , self directory fullName printString , ' -interaction=batchmode ' , (fullname , '.tex') printString.
	self process
		waitForCommand: latexCommand;
		waitForCommand: bibtexCommand;
		waitForCommand: indexCommand;
		waitForCommand: latexCommand;
		waitForCommand: latexCommand.
	stream := self directory oldFileNamed: self filename , '.pdf'.
	^ [ self streamFrom: stream to: aStream ]
		ensure: [ stream close ] ]
			ensure: [ self directory recursiveDelete. directory := nil ]! !

!BOPdfView methodsFor: 'private' stamp: 'lr 5/19/2009 13:48'!
streamFrom: aSourceStream to: aTargetStream
	aSourceStream binary. 
	aTargetStream binary.
	[ aSourceStream atEnd ] 
		whileFalse: [ aTargetStream nextPutAll: (aSourceStream next: 1024) ]! !

PRWidget subclass: #BONoteWidget
	instanceVariableNames: 'component command note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Utilities'!

!BONoteWidget class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:41'!
isAbstract
	^ false! !

!BONoteWidget class methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:41'!
label
	^ 'Book Notes'! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:55'!
buildCommand
	^ (self context
		structure: self note
		command: self note editCommandClass new)
			command! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:54'!
buildComponent
	^ (self buildDescription asComponentOn: self command)
		onAnswer: [ :result | self execute: result ];
		addValidatedForm;
		yourself! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:55'!
buildDescription
	^ self command description select: [ :each | each propertyAt: #public ifAbsent: [ false ] ]! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:56'!
buildNote
	^ BONote new
		title: self context structure title;
		yourself! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:54'!
children
	^ Array with: self component! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:55'!
command
	^ command ifNil: [ command := self buildCommand ]! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:54'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!BONoteWidget methodsFor: 'actions' stamp: 'lr 5/3/2009 13:02'!
execute: anEditCommand
	| addCommand |
	note := component := command := nil.
	anEditCommand ifNil: [ ^ self ].
	addCommand := PRAddCommand new.
	self context command: addCommand.
	addCommand
		name: (addCommand
			uniqueName: 'note'
			in: self context structure);
		type: BONote;
		beUnchecked;
		execute.
	self context
		structure: addCommand answer structure
		command: anEditCommand.
	anEditCommand
		beUnchecked;
		execute! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:57'!
note
	^ note ifNil: [ note := self buildNote ]! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:40'!
notes
	^ (self context enumerator
		select: [ :each | each isNote ])
		asSortedCollection: [ :a :b | a timestamp > b timestamp ]! !

!BONoteWidget methodsFor: 'rendering-adding' stamp: 'lr 5/3/2009 17:09'!
renderAddOn: html
	html div class: 'addnote'; with: [
		html heading: 'Add a Note'.
		html render: self component ]! !

!BONoteWidget methodsFor: 'rendering' stamp: 'lr 5/19/2009 11:38'!
renderContentOn: html
	self context structure isPublication
		ifFalse: [ ^ self ].
	html div class: 'notes'; with: [
		self renderNotes: self notes on: html.
		self renderAddOn: html ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:25'!
renderNote: aNote on: html
	html div class: 'note'; with: [ 
		self renderNoteMeta: aNote on: html.
		self renderNoteBody: aNote on: html ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 17:18'!
renderNoteBody: aNote on: html
	| line |
	html div class: 'body'; with: [
		aNote note lines do: [ :string |
			line := string.
			html paragraph: [
				line isEmpty
					ifTrue: [ html space ]
					ifFalse: [
						[ line notEmpty and: [ line first = $ ] ]
							whileTrue: [ html space. line := line copyWithoutFirst ].
						html text: line ] ] ] ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:33'!
renderNoteMeta: aNote on: html 
	html div class: 'meta'; with: [
		self renderNoteMetaAuthor: aNote on: html.
		self renderNoteMetaPublication: aNote on: html.
		self renderNoteMetaCommands: aNote on: html ]! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:32'!
renderNoteMetaAuthor: aNote on: html.
	html span
		class: 'author';
		with: aNote author.
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 12:48'!
renderNoteMetaCommands: aNote on: html
	| commands contexts |
	commands := Array with: PREditCommand with: PRMoveCommand with: PRRemoveCommand.
	contexts := (commands
		collect: [ :class | self context structure: aNote command: class new ])
		select: [ :each | each isValid ].
	contexts isEmpty ifTrue: [ ^ self ].
	html span class: 'commands'; with: [
		contexts
			do: [ :each | html anchor goto: each; with: each command label ]
			separatedBy: [ html text: ', ' ] ].
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 13:10'!
renderNoteMetaPublication: aNote on: html 
	html span
		class: 'publication';
		with: '(' , aNote timestamp date printString , 
			', ' , aNote timestamp time printMinutes ,
			')'.
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-listing' stamp: 'lr 5/3/2009 17:15'!
renderNotes: aCollection on: html
	aCollection isEmpty
		ifTrue: [ ^ self ].
	html div class: 'listing'; with: [
		html heading: 'User Contributed Notes'.
		aCollection do: [ :each |
			self renderNote: each on: html ] ]! !

PRFile subclass: #BOFigure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOFigure class methodsFor: 'testing' stamp: 'lr 6/3/2009 21:48'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOPublication! !

!BOFigure class methodsFor: 'testing' stamp: 'lr 6/3/2009 23:42'!
canBeParentOf: aStructureClass
	^ false! !

!BOFigure class methodsFor: 'accessing-description' stamp: 'lr 6/3/2009 21:52'!
descriptionFile
	^ super descriptionFile
		addCondition: (MACondition selector: #isImage) labelled: 'Select an image';
		yourself! !

!BOFigure class methodsFor: 'initialization' stamp: 'lr 6/3/2009 23:30'!
initialize
	PRFile allInstances do: [ :structure |
		(structure findAncestor: [ :each | each isPublication ]) notNil
			ifTrue: [ structure primitiveChangeClassTo: self basicNew ] ]! !

!BOFigure class methodsFor: 'accessing' stamp: 'lr 6/3/2009 21:50'!
label
	^ 'Figure'! !

!BOFigure methodsFor: 'visiting' stamp: 'lr 6/3/2009 21:50'!
accept: aVisitor
	aVisitor visitFigure: self! !

!BOFigure methodsFor: 'accessing' stamp: 'lr 6/3/2009 23:06'!
index
	"Answer the index number of this figure."

	| root siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	root := self parent
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	siblings := root enumerator everything
		select: [ :each | each isFigure ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOFigure methodsFor: 'testing' stamp: 'lr 6/3/2009 22:44'!
isFigure
	^ true! !

!BOFigure methodsFor: 'accessing' stamp: 'lr 6/3/2009 23:07'!
number
	^ self index asString! !

PRCase subclass: #BOPublication
	instanceVariableNames: 'numberedTitle ignoredTitle ignoredBody'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

BOPublication subclass: #BOBook
	instanceVariableNames: 'subtitle tagline authors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOBook class methodsFor: 'testing' stamp: 'lr 5/13/2009 09:05'!
canBeChildOf: aStructureClass
	^ (aStructureClass includesBehavior: BOPublication) not! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:38'!
descriptionAuthors
	^ MAStringDescription new
		parameterName: 'authors';
		accessor: #authors;
		label: 'Authors';
		beSearchable;
		priority: 400;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 5/19/2009 15:37'!
descriptionNumberedTitle
	^ nil! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionSubtitle
	^ MAStringDescription new
		parameterName: 'subtitle';
		accessor: #subtitle;
		label: 'Subtitle';
		beSearchable;
		priority: 200;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionTagline
	^ MAStringDescription new
		parameterName: 'tagline';
		accessor: #tagline;
		label: 'Tagline';
		beSearchable;
		priority: 300;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'testing' stamp: 'lr 5/2/2009 12:33'!
isAbstract
	^ false! !

!BOBook class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:31'!
label
	^ 'Book'! !

!BOBook methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitBook: self! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors
	^ authors! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors: anObject
	authors := anObject! !

!BOBook methodsFor: 'accessing-commands' stamp: 'lr 5/26/2009 21:44'!
defaultChildClass
	^ BOPart! !

!BOBook methodsFor: 'accessing-dynamic' stamp: 'lr 5/2/2009 21:39'!
index
	^ nil! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:25'!
isBook
	^ true! !

!BOBook methodsFor: 'accessing-dynamic' stamp: 'lr 5/2/2009 21:39'!
number
	^ nil! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle
	^ subtitle! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle: aString
	subtitle := aString! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline
	^ tagline! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline: aString
	tagline := aString! !

BOPublication subclass: #BOChapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOChapter class methodsFor: 'testing' stamp: 'lr 5/13/2009 09:04'!
canBeChildOf: aStructureClass
	^ (aStructureClass includesBehavior: BOBook) or: [ aStructureClass includesBehavior: BOPart ]! !

!BOChapter class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Chapter'! !

!BOChapter methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitChapter: self! !

!BOChapter methodsFor: 'accessing-commands' stamp: 'lr 5/26/2009 21:45'!
defaultChildClass
	^ BOSection! !

!BOChapter methodsFor: 'accessing' stamp: 'lr 5/19/2009 15:30'!
index
	"Answer the chapter of this publication. Chapters can be on different levels, thus we need different numbering algorithm."
	
	| root siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	root := self parent
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	siblings := root enumerator everything
		select: [ :each | each isPublication and: [ each isChapter and: [ each isNumberedTitle ] ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOChapter methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isChapter
	^ true! !

BOPublication subclass: #BOPart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOPart class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:15'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOBook! !

!BOPart class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:37'!
label
	^ 'Book Part'! !

!BOPart methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitPart: self! !

!BOPart methodsFor: 'private' stamp: 'lr 5/2/2009 15:56'!
arabicToRoman: anInteger
	"Convert an arabic integer to a roman string."
	
	| number roman |
	number := anInteger.
	roman := WriteStream on: String new.
	#((1000 'M') (900 'CM') (500 'D') (400 'CD') (100 'C') (90 'XC') (50 'L') (40 'XL') (10 'X') (9 'IX') (5 'V') (4 'IV') (1 'I')) do: [ :pair |
		[ number >= pair first ] whileTrue: [
			roman nextPutAll: pair second.
			number := number - pair first ] ].
	^ roman contents! !

!BOPart methodsFor: 'accessing-commands' stamp: 'lr 5/26/2009 21:44'!
defaultChildClass
	^ BOChapter! !

!BOPart methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:28'!
index
	^ nil! !

!BOPart methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ true! !

!BOPart methodsFor: 'accessing' stamp: 'lr 6/4/2009 00:05'!
number
	^ self arabicToRoman: (super index ifNil: [ ^ nil ])! !

!BOPublication class methodsFor: 'testing' stamp: 'lr 5/26/2009 21:38'!
canBeParentOf: aStructureClass
	^ self childClasses anySatisfy: [ :class | aStructureClass includesBehavior: class ]! !

!BOPublication class methodsFor: 'accessing' stamp: 'lr 6/3/2009 21:50'!
childClasses
	^ Array with: BOPublication with: BONote with: BOFigure! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 5/19/2009 15:32'!
descriptionIgnoredBody
	^ MABooleanDescription new
		checkboxLabel: 'Ignore body';
		accessor: #ignoredBody;
		default: false;
		priority: 162;
		beEditable;
		yourself! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 5/19/2009 15:32'!
descriptionIgnoredTitle
	^ MABooleanDescription new
		checkboxLabel: 'Ignore title';
		accessor: #ignoredTitle;
		label: 'Export';
		default: false;
		priority: 160;
		beEditable;
		yourself! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 4/24/2009 12:20'!
descriptionNumber
	^ MAStringDescription new
		parameterName: 'number';
		accessor: #number;
		beReadonly;
		yourself! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 5/19/2009 15:33'!
descriptionNumberedTitle
	^ MABooleanDescription new
		checkboxLabel: 'Numbered title';
		accessor: #numberedTitle;
		label: 'Display';
		default: true;
		priority: 150;
		beEditable;
		yourself! !

!BOPublication class methodsFor: 'testing' stamp: 'lr 5/26/2009 21:46'!
isAbstract
	^ self name = #BOPublication! !

!BOPublication methodsFor: 'comparing' stamp: 'lr 4/24/2009 12:10'!
< aStructure
	| siblings |
	(self parent isNil or: [ self parent ~= aStructure parent ])
		ifTrue: [ ^ super < aStructure ].
	(aStructure isPublication)
		ifFalse: [ ^ false ].
	siblings := self parent childrenDecoration children.
	^ (siblings indexOf: self) < (siblings indexOf: aStructure)
		! !

!BOPublication methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitPublication: self! !

!BOPublication methodsFor: 'accessing-settings' stamp: 'lr 5/19/2009 15:30'!
ignoredBody
	^ ignoredBody! !

!BOPublication methodsFor: 'accessing-settings' stamp: 'lr 5/19/2009 15:30'!
ignoredBody: aBoolean
	ignoredBody := aBoolean! !

!BOPublication methodsFor: 'accessing-settings' stamp: 'lr 5/19/2009 15:29'!
ignoredTitle
	^ ignoredTitle! !

!BOPublication methodsFor: 'accessing-settings' stamp: 'lr 5/19/2009 15:29'!
ignoredTitle: aBoolean
	ignoredTitle := aBoolean! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/19/2009 15:31'!
index
	"Answer the index number of this publication, for example the chapter or section number."
	
	| siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	siblings := self parent childrenDecoration children select: [ :each | 
		each isPublication 
			and: [ each isNumberedTitle
			and: [ each class = self class ] ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isBook
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:40'!
isChapter
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/19/2009 15:36'!
isIgnoredBody
	^ self ignoredBody ifNil: [ false ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/19/2009 15:30'!
isIgnoredTitle
	^ self ignoredTitle ifNil: [ false ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/19/2009 15:30'!
isNumberedTitle
	^ self numberedTitle ifNil: [ true ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/23/2009 19:32'!
isPublication
	^ true! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ false! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:33'!
number
	"Answer the composed numbers."

	| book publications |
	book := self 
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	publications := (self parents
		select: [ :each | each isPublication ])
		copyAfter: book.
	^ (((publications	
		collect: [ :each | each index ])
		reject: [ :each | each isNil ])
		collect: [ :each | each asString ])
		reduce: [ :a :b | a , '.' , b ]! !

!BOPublication methodsFor: 'accessing-settings' stamp: 'lr 5/19/2009 15:29'!
numberedTitle
	^ numberedTitle! !

!BOPublication methodsFor: 'accessing-settings' stamp: 'lr 5/19/2009 15:29'!
numberedTitle: aBoolean
	numberedTitle := aBoolean! !

BOPublication subclass: #BOSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOSection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:34'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOChapter! !

!BOSection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Section'! !

!BOSection methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:30'!
accept: aVisitor
	aVisitor visitSection: self! !

!BOSection methodsFor: 'accessing-commands' stamp: 'lr 5/26/2009 21:45'!
defaultChildClass
	^ BOSubsection! !

!BOSection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ true! !

BOPublication subclass: #BOSubsection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOSubsection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:33'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOSection! !

!BOSubsection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Subsection'! !

!BOSubsection methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:31'!
accept: aVisitor
	aVisitor visitSubsection: self! !

!BOSubsection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ true! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 5/13/2009 11:16'!
visitBook: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 5/13/2009 11:17'!
visitChapter: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 6/3/2009 21:53'!
visitFigure: anObject
	self visitFile: anObject! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 5/1/2009 22:11'!
visitIndexLink: aLink
	self visitLink: aLink! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 5/13/2009 11:17'!
visitPart: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 5/13/2009 11:16'!
visitPublication: aStructure
	self visitCase: aStructure! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 5/13/2009 11:17'!
visitSection: aStructure
	self visitPublication: aStructure! !

!PRVisitor methodsFor: '*pier-book-model' stamp: 'lr 5/13/2009 11:17'!
visitSubsection: aStructure
	self visitPublication: aStructure! !

Object subclass: #BOLatexWrapper
	instanceVariableNames: 'stream'
	classVariableNames: 'LatexCharacters'
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOLatexWrapper class methodsFor: 'initialization' stamp: 'lr 5/13/2009 08:59'!
initialize
	LatexCharacters := Dictionary new.
	LatexCharacters
		at: $# put: '\#';
		at: $& put: '\&';
		at: $% put: '\%';
		at: $$ put: '\$';
		at: ${ put: '\{';
		at: $} put: '\}';
		at: $" put: '\symbol{34}';
		" -- "
		at: $[ put: '{[}';
		at: $] put: '{]}';
		at: $| put: '$|$';
		at: $< put: '$<$';
		at: $> put: '$>$';
		at: $/ put: '$/$';
		at: $\ put: '$\backslash$';
		at: $_ put: '$\leftarrow$';
		at: $^ put: '$\uparrow$';
		" -- "
		at: $ put: '\"{a}';
		at: $ put: '\"{A}';
		at: $ put: '\"{e}';
		at: $ put: '\"{E}';
		at: $ put: '\"{i}';
		at: $ put: '\"{I}';
		at: $ put: '\"{o}';
		at: $ put: '\"{O}';
		at: $ put: '\"{u}';
		at: $ put: '\"{U}';
		at: $ put: '\"{y}';
		at: $ put: '\"{Y}';
		" -- "
		at: $ put: '\^{a}';
		at: $ put: '\^{A}';
		at: $ put: '\^{e}';
		at: $ put: '\^{E}';
		at: $ put: '\^{i}';
		at: $ put: '\^{I}';
		at: $ put: '\^{o}';
		at: $ put: '\^{O}';
		at: $ put: '\^{u}';
		at: $ put: '\^{U}';
		" -- "
		at: $ put: '\`{a}';
		at: $ put: '\`{A}';
		at: $ put: '\`{e}';
		at: $ put: '\`{E}';
		at: $ put: '\`{i}';
		at: $ put: '\`{I}';
		at: $ put: '\`{o}';
		at: $ put: '\`{O}';
		at: $ put: '\`{u}';
		at: $ put: '\`{U}';
		" -- "
		at: $ put: '\''{a}';
		at: $ put: '\''{A}';
		at: $ put: '\''{e}';
		at: $ put: '\''{i}';
		at: $ put: '\''{I}';
		at: $ put: '\''{o}';
		at: $ put: '\''{O}';
		at: $ put: '\''{u}';
		at: $ put: '\''{U}';
		" -- "
		at: $ put: '\c{c}';
		at: $ put: '\c{C}';
		" -- "
		at: $~ put: '\~{}';
		at: $ put: '\~{n}';
		at: $ put: '\~{N}'! !

!BOLatexWrapper class methodsFor: 'instance creation' stamp: 'lr 5/13/2009 11:21'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/19/2009 15:53'!
comment: anObject
	stream nextPut: $%; space; nextPutAll: anObject asString; lf! !

!BOLatexWrapper methodsFor: 'accessing' stamp: 'lr 5/13/2009 11:24'!
contents
	^ stream contents! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/19/2009 15:58'!
cr! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/19/2009 15:53'!
curly: anObject
	stream nextPut: ${.
	self print: anObject.
	stream nextPut: $}! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/19/2009 15:58'!
environment: aString do: anObject
	self tag: 'begin'; curly: aString; lf.
	self print: anObject.
	self tag: 'end'; curly: aString; lf! !

!BOLatexWrapper methodsFor: 'initialization' stamp: 'lr 5/13/2009 09:09'!
initializeOn: aStream
	stream := aStream! !

!BOLatexWrapper methodsFor: 'testing' stamp: 'lr 5/13/2009 11:23'!
isEmpty
	^ stream isEmpty! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/19/2009 15:52'!
lf
	(stream position isZero
		or: [ stream position > 1
		and: [ (stream contents at: stream position) = Character lf
		and: [ (stream contents at: stream position - 1) = Character lf ] ] ])
			ifTrue: [ ^ self ].
	stream lf! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/19/2009 15:04'!
nextPut: aCharacter
	| string |
	string := LatexCharacters at: aCharacter ifAbsent: nil.
	string isNil
		ifTrue: [ stream nextPut: aCharacter ]
		ifFalse: [ stream nextPutAll: string ]! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 08:59'!
nextPutAll: anObject
	anObject asString do: [ :each | self nextPut: each ]! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/13/2009 08:59'!
print: anObject
	anObject printLatexOn: self! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/19/2009 15:06'!
space
	stream space! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/19/2009 15:54'!
square: anObject
	stream nextPut: $[.
	self print: anObject.
	stream nextPut: $]! !

!BOLatexWrapper methodsFor: 'accessing' stamp: 'lr 5/13/2009 11:04'!
stream
	^ stream! !

!BOLatexWrapper methodsFor: 'streaming' stamp: 'lr 5/19/2009 15:06'!
tab
	stream tab! !

!BOLatexWrapper methodsFor: 'conveniance' stamp: 'lr 5/19/2009 15:54'!
tag: aString
	stream nextPut: $\; nextPutAll: aString! !

!PRLinkRenderer methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:35'!
visitIndexLink: aLink
	html anchor name: aLink title.
	parent visitAll: aLink children! !

PRDocumentWriter subclass: #BOLatexWriter
	instanceVariableNames: 'structures latex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Latex'!

!BOLatexWriter methodsFor: 'generating' stamp: 'lr 5/19/2009 15:56'!
generatePublication: aStructure type: aString
	latex lf; lf.
	latex
		comment: aStructure absolutePath.
	aStructure isIgnoredTitle
		ifTrue: [ ^ self ].
	latex
		tag: aString;
		print: (aStructure isNumberedTitle
			ifFalse: [ '*' ]);
		curly: aStructure title;
		lf.
	latex
		tag: 'label';
		curly: (self labelFor: aStructure);
		lf; lf! !

!BOLatexWriter methodsFor: 'queries' stamp: 'lr 6/4/2009 00:10'!
header
	^ '% This is an automatically generated file, do not modify manually!!
\documentclass[a4paper,11pt,twoside,openright]{book}

% packages
\usepackage{color}
\usepackage{xcolor}
\usepackage{xspace}
\usepackage{ifthen}
\usepackage{amsbsy}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage[english]{babel}
\usepackage[parfill]{parskip}
\usepackage[normalem]{ulem}

% references
\usepackage{hyperref}
\usepackage[all]{hypcap}
\definecolor{blue}{rgb}{0,0,0.4}
\setcounter{tocdepth}{2}
\urlstyle{sf}
\hypersetup{
	a4paper,
	colorlinks=true,
	linkcolor=blue, 
	anchorcolor=blue,
	citecolor=blue,
	filecolor=blue,
	pagecolor=blue,
	urlcolor=blue,
	plainpages=false,
	bookmarksopen=true,
	bookmarksopenlevel=2}
	
% source code
\usepackage{listings}
\definecolor{source}{gray}{0.95}
\lstset{
	language={},
	% characters
	tabsize=4,
	upquote=true,
	escapechar={!!},
	keepspaces=true,
	breaklines=true,
	alsoletter={\#:},
	breakautoindent=true,
	columns=fullflexible,
	showstringspaces=false,
	basicstyle=\small\sffamily,
	% background
	frame=single,
	framerule=0pt,
	backgroundcolor=\color{source},
	% numbering
	numbersep=5pt,
	numberstyle=\tiny,
	numberfirstline=true,
	% captioning
	captionpos=b,
	% formatting (html)
	moredelim=[is][\textbf]{<b>}{</b>},
	moredelim=[is][\textit]{<i>}{</i>},
	% characters
	literate=
        {~}{{\raisebox{-1.5ex}{\Large\~{}}}}1
        {-}{{\sf -\hspace{-0.13em}-}}1
        {+}{{\raisebox{0.08ex}{+}}}1
        {>>}{\raisebox{0.3ex}{\hspace{0.1em}\tiny$\boldsymbol{\gg}$\hspace{0.2em}}}1,
}
\newcommand{\ct}{\lstinline[backgroundcolor=\color{white}]}

% environments
\newenvironment{important}%
	{\marginpar{\raggedright\hspace{0pt}\color{blue}Important}}%
	{}
\newenvironment{seaside28}%
	{\marginpar{\raggedright\hspace{0pt}\color{orange}Seaside 2.8}}%
	{}
\newenvironment{seaside29}%
	{\marginpar{\raggedright\hspace{0pt}\color{orange}Seaside 2.9}}%
	{}
\newenvironment{todo}%
	{\marginpar{\raggedright\hspace{0pt}\color{red}TODO}}%
	{}
\newenvironment{blockquote}%
	{\begin{quote}}
	{\end{quote}}

% keyword index 
\usepackage{makeidx}
\makeindex

% graphics
\usepackage{graphicx}
\DeclareGraphicsExtensions{.png,.jpg,.pdf,.gif}

% references
\def\partautorefname{Part}
\def\chapterautorefname{Chapter}
\def\sectionautorefname{Section}
\def\subsectionautorefname{Section}
\def\figureautorefname{Figure}
\def\tableautorefname{Table}

% fomatting
\sloppy'! !

!BOLatexWriter methodsFor: 'queries' stamp: 'lr 5/13/2009 16:19'!
labelFor: aStructure
	| parents |
	parents := aStructure parents
		copyAfter: (aStructure 
			findAncestor: [ :each | each isPublication and: [ each isBook ] ]).
	^ (parents collect: [ :each | each name ])	
		reduce: [ :a :b | a , ':' , b ]! !

!BOLatexWriter methodsFor: 'accessing' stamp: 'lr 5/13/2009 11:49'!
stream: aStream
	super stream: aStream.
	latex := BOLatexWrapper on: aStream.
	structures := OrderedCollection new! !

!BOLatexWriter methodsFor: 'visiting' stamp: 'lr 5/13/2009 11:50'!
visit: anObject
	| isPublication |
	isPublication := anObject isKindOf: BOPublication.
	isPublication
		ifTrue: [ structures addLast: anObject ].
	super visit: anObject.
	isPublication
		ifTrue: [ structures removeLast ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:56'!
visitAnchor: anObject
	latex tag: 'label'; curly: [ stream nextPutAll: anObject name ]; lf! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/26/2009 22:45'!
visitAnnotatedParagraph: anObject
	latex
		environment: anObject annotation
		do: [ super visitAnnotatedParagraph: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitBoldFormat: anObject
	latex tag: 'textbf'; curly: [ super visitBoldFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/25/2009 09:24'!
visitBook: aStructure
	stream nextPutAll: self header; lf.
	latex lf.

	latex comment: 'information'.
	latex tag: 'title'; curly: aStructure title; lf.
	latex tag: 'author'; curly: aStructure authors; lf.
	latex lf.

	latex comment: 'document'.
	latex tag: 'begin'; curly: 'document'; lf.
	latex lf.
	
	latex tag: 'frontmatter'; lf.
	latex tag: 'maketitle'; tag: 'newpage'; tag: 'cleardoublepage'; lf.
	latex tag: 'tableofcontents'; tag: 'newpage'; tag: 'cleardoublepage'; lf.
	latex lf.
	
	latex tag: 'mainmatter'; lf.
	latex lf.

	super visitBook: aStructure.
	
	latex lf.
	latex tag: 'backmatter'; lf.
	latex tag: 'printindex'; lf.
	latex tag: 'end'; curly: 'document'; lf! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/19/2009 15:14'!
visitCase: aStructure
	super visitCase: aStructure.
	self visit: aStructure document! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/19/2009 15:34'!
visitChapter: aStructure
	self generatePublication: aStructure type: 'chapter'.
	super visitChapter: aStructure! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 12:34'!
visitDataItem: anObject
	self visitParagraph: anObject! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 12:32'!
visitDefinitionList: anObject
	latex environment: 'description' do: [ super visitDefinitionList: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:57'!
visitEmptyParagraph: anObject
	latex lf! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:10'!
visitExternalLink: aLink
	latex
		tag: 'href';
		curly: [ stream nextPutAll: aLink url ];
		curly: [ super visitExternalLink: aLink ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:54'!
visitHeader: anObject
	| kind |
	kind := #('subsubsection' 'paragraph' 'subparagraph')
		at: (anObject level max: 3).
	latex tag: kind.
	stream nextPut: $*.
	latex curly: anObject text.
	stream lf! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 12:01'!
visitIndexLink: anObject
	latex tag: 'index'; curly: anObject title! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 6/3/2009 23:44'!
visitInternalLink: aLink
	aLink isBroken
		ifTrue: [ ^ latex tag: 'color'; curly: 'red'; curly: [ super visitInternalLink: aLink ] ].
	(aLink isEmbedded and: [ aLink target isFigure ]) ifTrue: [
		latex tag: 'begin'; curly: 'figure'; square: 'h!!tbp'; lf.
		latex tab; tag: 'begin'; curly: 'center'; lf.
		latex tab; tab; tag: 'includegraphics'; square: [ stream nextPutAll: 'width='; print: ((aLink parameterAt: 'width' ifAbsent: [ 100 ]) asNumber / 100.0); nextPutAll: '\textwidth' ]; curly: [ stream nextPutAll: (aLink target file directory fullNameFor: aLink target file filename) ]; lf.
		latex tab; tab; tag: 'caption'; curly: [
			aLink hasChildren
				ifTrue: [ super visitInternalLink: aLink ]
				ifFalse: [ latex nextPutAll: aLink target title ].
			latex tag: 'label'; curly: [ stream nextPutAll: (self labelFor: aLink target) ] ]; lf.
		latex tab; tag: 'end'; curly: 'center'; lf.
		^ latex tag: 'end'; curly: 'figure'; lf ].
	latex
		tag: 'hyperref';
		square: [ stream nextPutAll: (self labelFor: aLink target) ];
		curly: [ 
			aLink hasChildren
				ifTrue: [ super visitInternalLink: aLink ]
				ifFalse: [ latex nextPutAll: aLink target title ] ]! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitItalicFormat: anObject
	latex tag: 'textit'; curly: [ super visitItalicFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:57'!
visitLineBreak: anObject
	latex lf! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitLink: anObject
	anObject hasChildren
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ latex print: anObject reference ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:57'!
visitListItem: anObject
	latex tag: 'item'; space.
	super visitListItem: anObject.
	latex lf! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/19/2009 15:51'!
visitMonospaceFormat: anObject
	latex tag: 'ct'; curly: [ stream nextPutAll: anObject text ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:36'!
visitOrderedList: anObject
	latex environment: 'enumerate' do: [ super visitOrderedList: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:57'!
visitParagraph: anObject
	super visitParagraph: anObject.
	latex lf; lf! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/19/2009 15:34'!
visitPart: aStructure
	self generatePublication: aStructure type: 'part'.
	super visitPart: aStructure! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 16:08'!
visitPreformatted: anObject
	latex environment: 'lstlisting' do: [
		anObject children 
			do: [ :each | stream nextPutAll: each text; lf ] ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/19/2009 15:34'!
visitPublication: aStructure
	aStructure isIgnoredBody
		ifFalse: [ super visitPublication: aStructure ].
	aStructure enumerator do: [ :structure |
		structure isPublication
			ifTrue: [ self visit: structure ] ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/19/2009 15:34'!
visitSection: aStructure
	self generatePublication: aStructure type: 'section'.
	super visitSection: aStructure! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitStrikethroughFormat: anObject
	latex tag: 'sout'; curly: [ super visitStrikethroughFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitSubscriptFormat: anObject
	latex tag: 'raisebox'; curly: '-0.25em'; curly: [ super visitSubscriptFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-structure' stamp: 'lr 5/19/2009 15:34'!
visitSubsection: aStructure
	self generatePublication: aStructure type: 'subsection'.
	super visitSubsection: aStructure! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitSuperscriptFormat: anObject
	latex tag: 'raisebox'; curly: '0.25em'; curly: [ super visitSuperscriptFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:55'!
visitTable: anObject
	latex environment: 'tabular' do: [
		latex curly: (String new: anObject columnCount withAll: $l); lf.
		self visitAll: anObject children separatedBy: [ stream nextPutAll: '\\'; lf ] ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 15:55'!
visitTableRow: aTableRow
	self visitAll: aTableRow children separatedBy: [ stream nextPut: $& ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 16:28'!
visitTermItem: anObject
	latex tag: 'item'; curly: [ latex tag: 'textbf'; curly: [ self visitAll: anObject children ] ]; lf! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:37'!
visitText: anObject
	latex nextPutAll: anObject text! !

!BOLatexWriter methodsFor: 'visiting-formatting' stamp: 'lr 5/13/2009 11:37'!
visitUnderlineFormat: anObject
	latex tag: 'uline'; curly: [ super visitUnderlineFormat: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/13/2009 11:37'!
visitUnorderedList: anObject
	latex environment: 'itemize' do: [ super visitUnorderedList: anObject ]! !

!BOLatexWriter methodsFor: 'visiting-document' stamp: 'lr 5/19/2009 11:50'!
visitValueLink: anObject
	| value |
	value := anObject valueIn: PRCurrentContext value.
	value isNil
		ifTrue: [ ^ self visitLink: anObject ].
	(value isCollection and: [ value isString not ])
		ifTrue: [ ^ self visitAll: value ].
	(value isKindOf: PRDocumentItem)
		ifTrue: [ ^ self visit: value ].
	latex print: value! !

!WriteStream methodsFor: '*pier-book' stamp: 'lr 5/19/2009 16:00'!
lf
	self nextPut: Character lf! !

!PREmbeddedRenderer methodsFor: '*pier-book-model' stamp: 'lr 6/3/2009 23:41'!
visitFigure: anObject
	html div class: 'figure'; with: [
		super visitFigure: anObject.
		html label: [
			html span: [ html text: 'Figure '; render: anObject number; text: ':' ].
			html text: ' '; text: anObject title; text: '.' ] ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/28/2009 08:25'!
bookContentsIn: aContext
	<value: 'book.contents' comment: 'Display a table of contents.'>

	| result |
	^ self lookupStructure: aContext structure do: [ :root |
		result := PRDefinitionList new.
		root enumerator everything do: [ :structure |
			(structure isPublication and: [ structure isBook not ]) ifTrue: [
				(structure isPart and: [ result hasChildren ])
					ifTrue: [ result add: PRDefinitionList new ].				
				self 
					bookLabel: (structure number 
						ifNil: [ ' ' ])
					class: nil
					target: structure 
					to: result ] ].
		result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 6/3/2009 23:31'!
bookFiguresIn: aContext
	<value: 'book.figures' comment: 'Display a table of figures.'>

	| result |
	^ self lookupStructure: aContext structure do: [ :root |
		result := PRDefinitionList new.
		root enumerator everything do: [ :structure |
			structure isFigure ifTrue: [
				result
					add: (PRTermItem with: (PRText content: structure number));
					add: (PRDataItem with: (PRInternalLink new
						target: structure parent;
						anchor: structure name;
						add: (PRText content: structure title);
						yourself)) ] ].
		result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/19/2009 11:43'!
bookIndexIn: aContext
	<value: 'book.index' comment: 'Display an index of keywords.'>

	| structs |
	^ self lookupStructure: aContext structure do: [ :root |
		| index |
		index := Dictionary new.
		root enumerator everything do: [ :struct |
			struct outgoingReferences do: [ :refer |
				((refer isKindOf: BOIndexLink) and: [ refer title isEmpty not ]) ifTrue: [ 
					(index at: refer entries first ifAbsentPut: [ OrderedCollection new ])
						addLast: refer owner ] ] ].
		(index keys asSortedCollection: [ :a :b | a asLowercase < b asLowercase ])
			inject: PRDefinitionList new
			into: [ :list :word |
				structs := Set new.
				list add: (PRTermItem with: (PRText content: word)).
				(index at: word) do: [ :struct |
					(structs includes: struct) ifFalse: [ 
						structs add: struct.
						list add: (PRDataItem with: (PRInternalLink new
							anchor: word;
							target: struct;
							yourself)) ] ].
				list ] ]! !

!PRValueLink methodsFor: '*pier-book-private' stamp: 'lr 6/4/2009 00:04'!
bookLabel: aString class: aClassString target: aStructure to: aDefinitionList
	| number |
	aStructure ifNil: [ ^ nil ].
	^ aDefinitionList
		add: (PRTermItem with: (PRText content: (aStructure isNil
			ifTrue: [ '&nbsp;' ]
			ifFalse: [ aString ])));
		add: (PRDataItem with: (aStructure isNil
			ifTrue: [ PRText content: '&nbsp;' ]
			ifFalse: [
				number := aStructure number.
				number isNil 
					ifTrue: [ number := String new ]
					ifFalse: [ number := number , ' ' ].
				PRInternalLink new 
					parameterAt: 'title' put: number , aStructure title;
					parameterAt: 'class' put: aClassString;
					target: aStructure;
					yourself ]));
		yourself! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/28/2009 07:58'!
bookNavigationIn: aContext
	<value: 'book.navigation' comment: 'Display a navigation structure for books.'>

	| structures index result |
	^ self lookupStructure: aContext structure do: [ :structure |
		structures := (aContext enumeratorFor: aContext root) everything
			select: [ :each | each isPublication ].
		index := structures indexOf: (structure 
			findAncestor: [ :each | each isPublication ]).
		result := PRDefinitionList new.
		self 
			bookLabel: '&rarr;' class: 'navigation-next' target: (structures at: index + 1 ifAbsent: [ nil ]) to: result;
			bookLabel: '&larr;' class: 'navigation-prev' target: (structures at: index - 1 ifAbsent: [ nil ]) to: result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/28/2009 07:58'!
bookParentIn: aContext
	<value: 'book.parent' comment: 'Display the parent structure for books.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			bookLabel: '&sect;'
			class: 'navigation-parent'
			target: (structure isRoot
				ifFalse: [ structure parent findAncestor: [ :each | each isPublication ] ]) 
			to: PRDefinitionList new ]! !
BOFigure initialize!
BOLatexWrapper initialize!
